import { Injectable } from '@angular/core';
import { BehaviorSubject } from 'rxjs';

@Injectable({ providedIn: 'root' })
export class ModalService {
  private modals: Map<string, BehaviorSubject<boolean>> = new Map();

  getModalState(id: string): BehaviorSubject<boolean> {
    if (!this.modals.has(id)) {
      this.modals.set(id, new BehaviorSubject<boolean>(false));
    }
    return this.modals.get(id)!;
  }

  openModal(id: string) {
    this.getModalState(id).next(true);
  }

  closeModal(id: string) {
    this.getModalState(id).next(false);
  }
}
